#include "StdAfx.h"
#include "WASSetLang.h"

CWASSetLang::CWASSetLang(CWASActor *pActor) : CWASCommand(pActor)
{
}

CWASSetLang::~CWASSetLang(void)
{
}

void CWASSetLang::ExecuteAsync()
{


	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return;
	}	

	USES_UTF8_CONVERSION;

	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL += _T("/ne/MyLanguage.php");

	m_httpFacade.StopRequest();
	m_httpFacade.session().SetURL( W2U8(strURL.c_str()), pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);
	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));	
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().AddBodyVariable("action", W2U8(_T("set")));
	m_httpFacade.session().AddBodyVariable("langcode", W2U8(m_strLang.c_str()));
	
	m_httpFacade.session().SetKeepRawHeader(TRUE);
	m_httpFacade.SendRequest(this);

}

void CWASSetLang::OnRequestTimeout( CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/ )
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();	

	for (; it != observers.end(); ++it)
		if((*it)->OnGTWASActor_ResponseSetLanguage(m_pActor, GetID(), m_eError, m_LangData) == false)
			break;

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}

void CWASSetLang::OnWasResponse(trid_t trid,
								bool bSuccess,
								int /*nWinINetErrorCode*/, 
								int /*nHttpResponseCode*/, 
								LPCSTR /*szWasResCodeInHeader*/, 
								LPCSTR szWasResCodeInXml,
								nfc::CIkXMLDom * pDom)
{
	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
		{
			m_eError = wasError_Protocol;
		}

	}

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	for (; it != observers.end(); ++it)
		if((*it)->OnGTWASActor_ResponseSetLanguage(m_pActor, GetID(), m_eError, m_LangData) == false)
			break;

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}

bool CWASSetLang::ParseAndEventFire( nfc::CIkXMLDom * pDom )
{
	nfc::IIkXMLNode *pNode = NULL;
	nfc::IIkXMLAttribute *pAttr = NULL;

	if(pDom == NULL)
		return false;

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return false;
	}	


	return true;
}
